#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "Templates/SubclassOf.h"
#include "GameplayTagContainer.h"
#include "BaseBehaviourDetectionComponent.generated.h"

class UBaseBehaviourIncentive;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class UBaseBehaviourDetectionComponent : public UActorComponent
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TArray<TSubclassOf<UBaseBehaviourIncentive>> _incentiveClasses;

	UPROPERTY(EditAnywhere)
	FGameplayTag _id;

	UPROPERTY(EditInstanceOnly, Transient)
	TMap<FGameplayTag, UBaseBehaviourIncentive*> _incentives;

public:
	UBaseBehaviourDetectionComponent();
};

FORCEINLINE uint32 GetTypeHash(const UBaseBehaviourDetectionComponent) { return 0; }
